package io.zipcoder;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.*;
import java.util.stream.Collectors;

public class WC {
    private Iterator<String> si;
    Map<String, Integer> words = new HashMap<>();

    public WC(String fileName) {
        try {
            this.si = new Scanner(new FileReader(fileName));
        } catch (FileNotFoundException e) {
            System.out.println(fileName + " Does Not Exist");
            System.exit(-1);
        }
    }

    public WC(Iterator<String> si) {
        this.si = si;
    }

    public String listWords(){
        while(this.si.hasNext()){
            String pos = this.si.next().replaceAll("[^a-zA-Z0-9]", "");
            if (!words.containsKey(pos)){
                words.put(pos, 1);
            } else {
                words.put(pos, words.get(pos)+1);
            }
        }

        words = words.entrySet()
                .stream()
                .sorted(Map.Entry.comparingByValue(Comparator.reverseOrder()))
                .collect(Collectors.toMap(Map.Entry::getKey,
                        Map.Entry::getValue, (e1,e2) -> e1, LinkedHashMap::new));

        StringBuilder sb = new StringBuilder();
        for (String k : words.keySet()) sb.append(k + " - " + words.get(k) + "\n");
        return sb.toString();
    }
}
