package io.zipcoder;

import org.junit.Assert;
import org.junit.Test;

public class ParenCheckerTest {
    ParenChecker pc = new ParenChecker();

    @Test
    public void parenCheckerTest(){
        String test = "(This is a test that should return true)";
        boolean actual = pc.checkParens(test);
        Assert.assertTrue(actual);
    }

    @Test
    public void parenCheckerTest2(){
        String test = "(This is a test that should (also) return true)";
        boolean actual = pc.checkParens(test);
        Assert.assertTrue(actual);
    }

    @Test
    public void parenCheckerTest3(){
        String test = "(This one (is (true too)))";
        boolean actual = pc.checkParens(test);
        Assert.assertTrue(actual);
    }

    @Test
    public void parenCheckerTest4(){
        String test = "(This is a test that should return false";
        boolean actual = pc.checkParens(test);
        Assert.assertFalse(actual);
    }

    @Test
    public void parenCheckerTest5(){
        String test = "(This is a test that should (also) return false";
        boolean actual = pc.checkParens(test);
        Assert.assertFalse(actual);
    }

    @Test
    public void parenCheckerTest6(){
        String test = "(This one (is (false too))";
        boolean actual = pc.checkParens(test);
        Assert.assertFalse(actual);
    }

    @Test
    public void parenCheckerTest7(){
        String test = "(This one (is (false because it has ) too many parentheses)))";
        boolean actual = pc.checkParens(test);
        Assert.assertFalse(actual);
    }

    @Test
    public void checkPairsTest(){
        String test = "(This is a test{} that[] should<> return true)";
        boolean actual = pc.checkPairs(test);
        Assert.assertTrue(actual);
    }

    @Test
    public void checkPairs2Test(){
        String test = "(This is a test{ that[ should< (also)> return ]}true)";
        boolean actual = pc.checkPairs(test);
        Assert.assertTrue(actual);
    }

    @Test
    public void checkPairs3Test(){
        String test = "(This one (is (true{ [] \"\"} too)))";
        boolean actual = pc.checkPairs(test);
        Assert.assertTrue(actual);
    }

    @Test
    public void checkPairs4Test(){
        String test = "This \' should return false";
        boolean actual = pc.checkPairs(test);
        Assert.assertFalse(actual);
    }

    @Test
    public void checkPairs5Test(){
        String test = "This {\" )should return false";
        boolean actual = pc.checkPairs(test);
        Assert.assertFalse(actual);
    }

    @Test
    public void checkPairs6Test(){
        String test = "This {\" \"})should return false";
        boolean actual = pc.checkPairs(test);
        Assert.assertFalse(actual);
    }
}